"use strict";

exports.__esModule = true;
exports.windowMode = exports.pluginDidLoad = exports.reactClass = exports.reducer = exports.windowOptions = void 0;

var _electron = require("electron");

var _views = require("./views");

exports.reducer = _views.reducer;
exports.reactClass = _views.reactClass;
const screen = _electron.remote.screen;
const {
  workArea
} = screen.getPrimaryDisplay();
let {
  x,
  y,
  width,
  height
} = global.config.get('plugin.ShipInfo.bounds', workArea);

const validate = (n, min, range) => n != null && n >= min && n < min + range;

const withinDisplay = d => {
  const wa = d.workArea;
  return validate(x, wa.x, wa.width) && validate(y, wa.y, wa.height);
};

if (!screen.getAllDisplays().some(withinDisplay)) {
  ;
  ({
    x,
    y
  } = workArea);
}

if (width == null) {
  ;
  ({
    width
  } = workArea);
}

if (height == null) {
  ;
  ({
    height
  } = workArea);
}

const windowOptions = {
  height,
  width,
  x,
  y
};
exports.windowOptions = windowOptions;

const pluginDidLoad = () => {
  global.config.set('plugin.ShipInfo.shipTypeChecked');
};

exports.pluginDidLoad = pluginDidLoad;
const windowMode = true;
exports.windowMode = windowMode;