"use strict";

exports.__esModule = true;
exports.buildCsv = exports.fields = void 0;

var _lodash = require("lodash");

var _i18next = _interopRequireDefault(require("views/env-parts/i18next"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

let _slotitems;

let $slotitems;
let $ships;

const __ = _i18next["default"].getFixedT(null, ['poi-plugin-ship-info', 'resources']);

const getItemName = index => ship => {
  const itemId = (0, _lodash.get)(_slotitems, `${(0, _lodash.get)(ship, `slot.${index}`)}.api_slotitem_id`);
  return (0, _lodash.get)($slotitems, `${itemId}.api_name`, 'NA');
};

const getExItemName = ship => {
  const itemId = (0, _lodash.get)(_slotitems, `${(0, _lodash.get)(ship, 'exslot')}.api_slotitem_id`);
  return (0, _lodash.get)($slotitems, `${itemId}.api_name`, 'NA');
};

const buildConstFields = key => [{
  key,
  value: ship => (0, _lodash.get)(ship, `${key}.0`, 'NA')
}];

const buildSlotItemFields = index => [{
  key: `slot${index}`,
  value: getItemName(index)
}, {
  key: `slot${index}Alv`,
  value: ship => (0, _lodash.get)(_slotitems, `${(0, _lodash.get)(ship, `slot.${index}`)}.api_alv`, 'NA')
}, {
  key: `slot${index}Level`,
  value: ship => (0, _lodash.get)(_slotitems, `${(0, _lodash.get)(ship, `slot.${index}`)}.api_level`, 'NA')
}];

const buildKyoukaFields = () => [0, 1, 2, 3, 4].map(index => ({
  key: `kyouka${index}`,
  value: ship => (0, _lodash.get)(ship, `kyouka.${index}`, 'NA')
}));

const fields = ['id', 'name', 'yomi', 'fleetId', 'sallyArea', 'type', 'soku', 'lv', 'cond', '_karyoku', 'karyokuNow', ...buildConstFields('houg'), 'karyokuMax', '_raisou', 'raisouNow', ...buildConstFields('raig'), 'raisouMax', '_taiku', 'taikuNow', ...buildConstFields('tyku'), 'taikuMax', '_soukou', 'soukouNow', ...buildConstFields('souk'), 'soukouMax', '_lucky', 'luckyNow', ...buildConstFields('luck'), 'luckyMax', ...buildKyoukaFields(), 'kaihi', 'taisen', 'sakuteki', ...buildSlotItemFields(0), ...buildSlotItemFields(1), ...buildSlotItemFields(2), ...buildSlotItemFields(3), {
  key: 'exslot',
  value: getExItemName
}, {
  key: 'exslotAlv',
  value: ship => (0, _lodash.get)(_slotitems, `${(0, _lodash.get)(ship, 'exslot')}.api_alv`, 'NA')
}, {
  key: 'exslotLevel',
  value: ship => (0, _lodash.get)(_slotitems, `${(0, _lodash.get)(ship, 'exslot')}.api_level`, 'NA')
}, 'locked', 'nowhp', 'maxhp', 'losshp', 'repairtime', 'inDock', {
  key: 'after',
  value: ship => (0, _lodash.get)($ships, `${ship.after}.api_name`, 'NA')
}];
exports.fields = fields;

const buildCsv = (rows, sep = ',', end = '\n') => {
  const state = window.getStore();
  _slotitems = state.info.equips;
  $slotitems = state["const"].$equips;
  $ships = state["const"].$ships;
  const entries = (0, _lodash.map)(rows, row => (0, _lodash.map)(fields, field => field.key ? field.value(row) : (0, _lodash.get)(row, field)));
  const titles = (0, _lodash.map)(fields, field => __(field.key || field));
  entries.unshift(titles);
  return (0, _lodash.map)(entries, entry => entry.join(sep)).join(end);
};

exports.buildCsv = buildCsv;