"use strict";

exports.__esModule = true;
exports.Filter = void 0;

var _core = require("@blueprintjs/core");

var _react = _interopRequireDefault(require("react"));

var _reactFontawesome = _interopRequireDefault(require("react-fontawesome"));

var _styledComponents = _interopRequireDefault(require("styled-components"));

var _overlay = require("views/components/etc/overlay");

var _constants = require("../../constants");

var _layout = require("../components/layout");

var _levelRange = require("./level-range");

var _radio = require("./radio");

var _sallyArea = require("./sally-area");

var _shipType = require("./ship-type");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

const Content = _styledComponents["default"].div.withConfig({
  displayName: "filter__Content",
  componentId: "sc-1ihcyi4-0"
})(["max-width:80vw;display:flex;flex-wrap:wrap;"]);

const Filter = () => _react["default"].createElement(_overlay.Popover, {
  hasBackdrop: true
}, _react["default"].createElement(_core.Button, {
  minimal: true
}, _react["default"].createElement(_reactFontawesome["default"], {
  name: "filter"
})), _react["default"].createElement(_layout.Container, null, _react["default"].createElement(Content, null, _react["default"].createElement(_shipType.ShipTypeCheck, null)), _react["default"].createElement(Content, null, _react["default"].createElement(_levelRange.LevelRange, null)), _react["default"].createElement(Content, null, _react["default"].createElement(_radio.RadioCheck, {
  configKey: "lockedRadio",
  label: "Lock",
  options: _constants.lockedOptions,
  "default": 1
}), _react["default"].createElement(_radio.RadioCheck, {
  configKey: "expeditionRadio",
  label: "Expedition",
  options: _constants.expeditionOptions,
  "default": 0
}), _react["default"].createElement(_radio.RadioCheck, {
  configKey: "inFleetRadio",
  label: "In Fleet",
  options: _constants.inFleetOptions,
  "default": 0
}), _react["default"].createElement(_radio.RadioCheck, {
  configKey: "modernizationRadio",
  label: "Modernization",
  options: _constants.modernizationOptions,
  "default": 0
}), _react["default"].createElement(_radio.RadioCheck, {
  configKey: "remodelRadio",
  label: "Remodelable",
  options: _constants.remodelOptions,
  "default": 0
}), _react["default"].createElement(_radio.RadioCheck, {
  configKey: "sparkleRadio",
  label: "Sparkle",
  options: _constants.sparkleOptions,
  "default": 0
}), _react["default"].createElement(_radio.RadioCheck, {
  configKey: "exSlotRadio",
  label: "Extra Slot",
  options: _constants.exSlotOptions,
  "default": 0
}), _react["default"].createElement(_radio.RadioCheck, {
  configKey: "daihatsuRadio",
  label: "Daihatsu",
  options: _constants.daihatsuOptions,
  "default": 0
})), _react["default"].createElement(Content, null, _react["default"].createElement(_sallyArea.SallyAreaCheck, null)), _react["default"].createElement(Content, null, _react["default"].createElement(_radio.RadioCheck, {
  configKey: "rawValue",
  label: "Value Type",
  options: _constants.rawValueOptions,
  "default": 0
}))));

exports.Filter = Filter;