"use strict";

exports.__esModule = true;
exports.LevelRange = void 0;

var _core = require("@blueprintjs/core");

var _lodash = require("lodash");

var _react = _interopRequireWildcard(require("react"));

var _reactFontawesome = _interopRequireDefault(require("react-fontawesome"));

var _reactI18next = require("react-i18next");

var _reactRedux = require("react-redux");

var _checkbox = require("../components/checkbox");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj["default"] = obj; return newObj; } }

// tslint:disable jsx-no-lambda
const LevelRange = (0, _reactRedux.connect)(state => ({
  maxLevel: (0, _lodash.get)(state.config, 'plugin.ShipInfo.filters.maxLevel', 10000),
  minLevel: (0, _lodash.get)(state.config, 'plugin.ShipInfo.filters.minLevel', 1)
}))(({
  minLevel,
  maxLevel
}) => {
  const [min, setMin] = (0, _react.useState)(minLevel);
  const [max, setMax] = (0, _react.useState)(maxLevel);
  const {
    t
  } = (0, _reactI18next.useTranslation)('poi-plugin-ship-info');
  const updateMax = (0, _react.useCallback)((0, _lodash.debounce)(v => {
    setMax(v);
    window.config.set('plugin.ShipInfo.filters.maxLevel', v);
  }, 500), [setMax]);
  const updateMin = (0, _react.useCallback)((0, _lodash.debounce)(v => {
    setMin(v);
    window.config.set('plugin.ShipInfo.filters.minLevel', v);
  }, 500), [setMin]);
  return _react["default"].createElement(_checkbox.Checkbox, null, _react["default"].createElement(_checkbox.CheckboxLabel, null, t('Level')), _react["default"].createElement(_core.NumericInput, {
    buttonPosition: "none",
    value: min,
    onValueChange: updateMin,
    min: 1,
    max: 1000,
    stepSize: 1,
    clampValueOnBlur: true
  }), _react["default"].createElement(_reactFontawesome["default"], {
    name: "arrows-alt-h"
  }), _react["default"].createElement(_core.NumericInput, {
    buttonPosition: "none",
    value: max,
    onValueChange: updateMax,
    min: 1,
    max: 1000,
    stepSize: 1,
    clampValueOnBlur: true
  }));
});
exports.LevelRange = LevelRange;