"use strict";

exports.__esModule = true;
exports.SallyAreaCheck = void 0;

var _lodash = require("lodash");

var _polished = require("polished");

var _react = _interopRequireWildcard(require("react"));

var _reactI18next = require("react-i18next");

var _reactRedux = require("react-redux");

var _redux = require("redux");

var _checkbox = require("../components/checkbox");

var _temp;

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj["default"] = obj; return newObj; } }

const SallyAreaCheck = (0, _redux.compose)((0, _reactI18next.withTranslation)(['poi-plugin-ship-info']), (0, _reactRedux.connect)(state => {
  const displayFleetName = (0, _lodash.get)(state.config, 'plugin.ShipInfo.displayFleetName', false);
  const mapname = displayFleetName ? (0, _lodash.get)(state, ['fcd', 'shiptag', 'fleetname', window.language], []) : (0, _lodash.get)(state, ['fcd', 'shiptag', 'mapname'], []);
  const defaultChecked = Array(mapname.length + 1).fill(true);
  let checked = (0, _lodash.get)(state.config, 'plugin.ShipInfo.sallyAreaChecked', defaultChecked); // reset config values if updated

  checked = mapname.length + 1 === checked.length ? checked : defaultChecked;
  const checkedAll = checked.reduce((a, b) => a && b, true);
  return {
    checked,
    checkedAll,
    color: (0, _lodash.get)(state, 'fcd.shiptag.color', []),
    displayFleetName,
    mapname
  };
}))((_temp = class SallyAreaCheckBase extends _react.Component {
  constructor(...args) {
    super(...args);

    this.handleClickBox = index => () => {
      const checked = this.props.checked.slice();
      let {
        checkedAll
      } = this.props;

      if (index === -1) {
        checkedAll = !checkedAll;
        checked.fill(checkedAll);
      } else {
        checked[index] = !checked[index];
        checkedAll = checked.reduce((a, b) => a && b, true);
      }

      window.config.set('plugin.ShipInfo.sallyAreaChecked', checked);
    };

    this.handleChangeDisplayFleetName = () => {
      window.config.set('plugin.ShipInfo.displayFleetName', !this.props.displayFleetName);
    };
  }

  render() {
    const {
      mapname,
      color,
      checked,
      checkedAll,
      displayFleetName,
      t
    } = this.props;
    return _react["default"].createElement(_checkbox.Checkbox, null, _react["default"].createElement(_checkbox.CheckboxLabel, null, t('Sally Area')), _react["default"].createElement(_checkbox.CheckboxOption, {
      key: -2,
      checked: checkedAll,
      onClick: this.handleClickBox(-1)
    }, t('All')), _react["default"].createElement(_checkbox.CheckboxOption, {
      key: -1,
      checked: checked[0],
      onClick: this.handleClickBox(0)
    }, t('Free')), mapname.map((name, idx) => _react["default"].createElement(_checkbox.CheckboxOption, {
      key: idx,
      onClick: this.handleClickBox(idx + 1),
      style: {
        backgroundColor: checked[idx + 1] ? (0, _polished.rgba)(color[idx], 0.75) : '',
        color: !checked[idx + 1] ? color[idx] : ''
      }
    }, t(name))));
  }

}, _temp));
exports.SallyAreaCheck = SallyAreaCheck;