"use strict";

exports.__esModule = true;
exports.ShipTypeCheck = void 0;

var _lodash = require("lodash");

var _react = _interopRequireWildcard(require("react"));

var _reactI18next = require("react-i18next");

var _reactRedux = require("react-redux");

var _redux = require("redux");

var _styledComponents = _interopRequireDefault(require("styled-components"));

var _constants = require("../../constants");

var _utils = require("../../utils");

var _checkbox = require("../components/checkbox");

var _temp;

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj["default"] = obj; return newObj; } }

const SuperTypeOption = (0, _styledComponents["default"])(_checkbox.CheckboxOption).withConfig({
  displayName: "ship-type__SuperTypeOption",
  componentId: "sc-19pg730-0"
})(["width:calc(100% / 9);"]);
const TypeOption = (0, _styledComponents["default"])(_checkbox.CheckboxOption).withConfig({
  displayName: "ship-type__TypeOption",
  componentId: "sc-19pg730-1"
})(["width:12.5%;"]);
const ShipTypeCheck = (0, _redux.compose)((0, _reactI18next.withTranslation)(['resources', 'poi-plugin-ship-info']), (0, _reactRedux.connect)((state, props) => {
  const $shipTypes = (0, _lodash.get)(state, 'const.$shipTypes', {});
  const defaultChecked = new Array((0, _lodash.size)($shipTypes)).fill(true);
  let checked = (0, _utils.intToBoolArray)((0, _lodash.get)(state.config, 'plugin.ShipInfo.shipTypes'));
  checked = defaultChecked.length === checked.length ? checked : defaultChecked;
  const checkedAll = checked.reduce((a, b) => a && b, true);
  return {
    $shipTypes,
    checked,
    checkedAll
  };
}))((_temp = class TypeView extends _react.Component {
  constructor(...args) {
    super(...args);

    this.getTypeArray = (checked, $shipTypes) => checked.reduce((types, isChecked, index) => isChecked && index + 1 in $shipTypes ? types.concat([index + 1]) : types, []);

    this.getArrayInclusion = (array, subArray) => (0, _lodash.isEqual)((0, _lodash.intersection)(array, subArray), subArray) && array.length > 0;

    this.getArrayIntersection = (array, subArray) => (0, _lodash.intersection)(array, subArray).length > 0 && subArray.length > (0, _lodash.intersection)(array, subArray).length;

    this.handleClickSuperType = (checkedTypes, index) => () => {
      const checked = this.props.checked.slice();
      const keys = _constants.shipSuperTypeMap[index].id;

      if (this.getArrayInclusion(checkedTypes, keys)) {
        keys.forEach(key => {
          checked[key - 1] = false;
        });
      } else {
        keys.forEach(key => {
          checked[key - 1] = true;
        });
      }

      window.config.set('plugin.ShipInfo.shipTypes', (0, _utils.boolArrayToInt)(checked));
    };

    this.handleRightClickSuperType = index => () => {
      const checked = this.props.checked.slice();
      const keys = _constants.shipSuperTypeMap[index].id;
      checked.fill(false);
      keys.forEach(key => {
        checked[key - 1] = true;
      });
      window.config.set('plugin.ShipInfo.shipTypes', (0, _utils.boolArrayToInt)(checked));
    };

    this.handleClickSingleBox = index => () => {
      const checked = this.props.checked.slice();
      let {
        checkedAll
      } = this.props;

      if (index === -1) {
        checkedAll = !checkedAll;
        checked.fill(checkedAll);
      } else {
        checked[index] = !checked[index];
      }

      window.config.set('plugin.ShipInfo.shipTypes', (0, _utils.boolArrayToInt)(checked));
    };

    this.handleRightClickSingleBox = index => () => {
      const checked = this.props.checked.slice();
      checked.fill(false);
      checked[index] = true;
      window.config.set('plugin.ShipInfo.shipTypes', (0, _utils.boolArrayToInt)(checked));
    };
  }

  render() {
    const {
      $shipTypes,
      checked,
      checkedAll,
      t
    } = this.props;
    const checkedTypes = checked.reduce((types, isChecked, index) => isChecked && index + 1 in $shipTypes ? types.concat([index + 1]) : types, []);
    return _react["default"].createElement("div", null, _react["default"].createElement(_checkbox.Checkbox, null, _react["default"].createElement(SuperTypeOption, {
      onClick: this.handleClickSingleBox(-1),
      checked: checkedAll
    }, t('All')), _constants.shipSuperTypeMap.map((supertype, index) => _react["default"].createElement(SuperTypeOption, {
      key: supertype.name,
      checked: this.getArrayInclusion(checkedTypes, supertype.id),
      partial: this.getArrayIntersection(checkedTypes, supertype.id),
      onClick: this.handleClickSuperType(checkedTypes, index),
      onContextMenu: this.handleRightClickSuperType(index)
    }, t(supertype.name)))), _react["default"].createElement(_checkbox.Checkbox, null, (0, _lodash.map)($shipTypes, (type, key) => _react["default"].createElement(TypeOption, {
      key: key,
      onClick: this.handleClickSingleBox(key - 1),
      onContextMenu: this.handleRightClickSingleBox(key - 1),
      checked: checked[key - 1]
    }, window.language === 'en-US' ? _utils.shipTypes[type.api_id] : t(type.api_name)))));
  }

}, _temp));
exports.ShipTypeCheck = ShipTypeCheck;