"use strict";

exports.__esModule = true;
exports.AddShip = void 0;

var _core = require("@blueprintjs/core");

var _classnames = _interopRequireDefault(require("classnames"));

var _fuse = _interopRequireDefault(require("fuse.js"));

var _lodash = _interopRequireWildcard(require("lodash"));

var _react = _interopRequireWildcard(require("react"));

var _reactFontawesome = _interopRequireDefault(require("react-fontawesome"));

var _reactI18next = require("react-i18next");

var _reactRedux = require("react-redux");

var _redux = require("redux");

var _styledComponents = _interopRequireDefault(require("styled-components"));

var _overlay = require("views/components/etc/overlay");

var _constants = require("../../constants");

var _selectors = require("../../selectors");

var _temp;

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj["default"] = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

const searchOptions = [{
  name: 'All',
  value: -1
}, ...(0, _lodash["default"])(_constants.shipSuperTypeMap).map(({
  name
}, index) => ({
  name,
  value: index
})).value()];

const Wrapper = _styledComponents["default"].div.withConfig({
  displayName: "add-ship__Wrapper",
  componentId: "sc-1fp2vz9-0"
})([".bp3-tab-panel{margin-top:0;}"]);

const ShipList = _styledComponents["default"].ul.withConfig({
  displayName: "add-ship__ShipList",
  componentId: "sc-1fp2vz9-1"
})(["padding:0;margin:0;height:30em;overflow-y:scroll;width:20em;span{cursor:pointer;}"]);

const ShipItem = _styledComponents["default"].li.withConfig({
  displayName: "add-ship__ShipItem",
  componentId: "sc-1fp2vz9-2"
})(["display:flex;padding:0.5em 1em;"]);

const ShipLv = _styledComponents["default"].span.withConfig({
  displayName: "add-ship__ShipLv",
  componentId: "sc-1fp2vz9-3"
})(["width:3em;"]);

const ShipName = _styledComponents["default"].span.withConfig({
  displayName: "add-ship__ShipName",
  componentId: "sc-1fp2vz9-4"
})(["flex:1;"]);

const Menu = (0, _redux.compose)((0, _reactI18next.withTranslation)('poi-plugin-ship-info'), (0, _reactRedux.connect)(state => ({
  allSelectedId: (0, _selectors.deckPlannerAllShipIdsSelector)(state),
  ships: (0, _selectors.shipMenuDataSelector)(state)
})))((_temp = class MenuBase extends _react.Component {
  constructor(props) {
    super(props);
    this.fuse = void 0;
    this.state = {
      query: ''
    };

    this.componentDidUpdate = prevProps => {
      if ((0, _lodash.values)(this.props.ships).length !== (0, _lodash.values)(prevProps.ships).length) {
        this.fuse.list = (0, _lodash.values)(this.props.ships);
        this.forceUpdate();
      }
    };

    this.handleQueryChange = e => {
      this.setState({
        query: e.currentTarget.value
      });
    };

    this.handleClear = () => {
      this.setState({
        query: ''
      });
    };

    this.handleSelect = id => () => {
      this.props.onSelect(id);
    };

    const options = {
      id: 'id',
      keys: ['name', 'yomi', 'romaji'],
      shouldSort: true
    };
    this.fuse = new _fuse["default"](props.ships, options);
  }

  render() {
    const {
      query
    } = this.state;
    const {
      ships,
      allSelectedId,
      t
    } = this.props;
    const filtered = (0, _lodash["default"])(this.fuse.search(query)).map(Number).value();
    return _react["default"].createElement(Wrapper, null, _react["default"].createElement(_core.InputGroup, {
      value: query,
      placeholder: t('Search'),
      onChange: this.handleQueryChange,
      rightElement: _react["default"].createElement(_core.Button, {
        minimal: true,
        onClick: this.handleClear,
        intent: _core.Intent.WARNING
      }, _react["default"].createElement(_reactFontawesome["default"], {
        name: "times"
      }))
    }), _react["default"].createElement(_core.Tabs, {
      vertical: true,
      id: "ship-selection",
      renderActiveTabPanelOnly: true
    }, (0, _lodash.map)(searchOptions, ({
      name,
      value: type
    }) => _react["default"].createElement(_core.Tab, {
      key: type,
      id: type,
      title: t(name),
      panel: _react["default"].createElement(ShipList, {
        className: "ship-info-scrollable"
      }, (0, _lodash["default"])(ships).filter(ship => type === -1 || type === ship.superTypeIndex).filter(ship => !query || (filtered || []).includes(ship.id)).filter(ship => !ship.area).filter(ship => !allSelectedId.includes(ship.id)).sortBy([ship => (filtered || []).indexOf(ship.id), ship => -ship.lv, ship => -ship.exp]).map(ship => _react["default"].createElement(ShipItem, {
        key: ship.id,
        onClick: this.handleSelect(ship.id),
        className: (0, _classnames["default"])(_core.Classes.POPOVER_DISMISS, _core.Classes.MENU_ITEM)
      }, _react["default"].createElement(ShipLv, null, "Lv.", (0, _lodash.padEnd)(String(ship.lv), 4)), _react["default"].createElement(ShipName, null, t(ship.name || '', {
        ns: 'resources'
      })), ship.area > 0 && _react["default"].createElement(_core.Tag, {
        intent: _core.Intent.PRIMARY
      }, ship.area))).value())
    }))));
  }

}, _temp)); // separate menu from popover component to prevent unnecessary updates

const AddShip = ({ ...props
}) => _react["default"].createElement(_overlay.Popover, {
  hasBackdrop: true
}, _react["default"].createElement(_core.Button, {
  minimal: true
}, _react["default"].createElement(_reactFontawesome["default"], {
  name: "plus"
})), _react["default"].createElement(Menu, props));

exports.AddShip = AddShip;