"use strict";

exports.__esModule = true;
exports.Area = void 0;

var _core = require("@blueprintjs/core");

var _lodash = require("lodash");

var _fp = _interopRequireDefault(require("lodash/fp"));

var _react = _interopRequireWildcard(require("react"));

var _reactFontawesome = _interopRequireDefault(require("react-fontawesome"));

var _reactRedux = require("react-redux");

var _styledComponents = _interopRequireDefault(require("styled-components"));

var _redux = require("../../redux");

var _selectors = require("../../selectors");

var _addShip = require("./add-ship");

var _shipChip = require("./ship-chip");

var _temp;

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj["default"] = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

const Container = (0, _styledComponents["default"])(_core.Card).withConfig({
  displayName: "area__Container",
  componentId: "sc-1vojx5c-0"
})(["padding:4px;"]);

const Header = _styledComponents["default"].div.withConfig({
  displayName: "area__Header",
  componentId: "sc-1vojx5c-1"
})(["display:flex;align-items:center;"]);

const Lane = _styledComponents["default"].div.withConfig({
  displayName: "area__Lane",
  componentId: "sc-1vojx5c-2"
})(["display:flex;flex-wrap:wrap;"]);

const Area = (0, _reactRedux.connect)((state, props) => ({
  shipIds: (0, _selectors.deckPlannerAreaSelectorFactory)(props.index)(state),
  ships: (0, _selectors.shipMenuDataSelector)(state)
}))((_temp = class AreaBase extends _react.Component {
  constructor(...args) {
    super(...args);

    this.handleAddShip = shipId => {
      this.props.dispatch((0, _redux.onAddShip)({
        areaIndex: this.props.index,
        shipId
      }));
    };
  }

  render() {
    const {
      area,
      index,
      others,
      ships,
      shipIds
    } = this.props;
    const keyShips = (0, _lodash.keyBy)(ships, 'id');
    const groupShipIds = (0, _lodash.groupBy)(shipIds, id => (keyShips[id] || {}).superTypeIndex);
    return _react["default"].createElement(Container, {
      interactive: true
    }, _react["default"].createElement(Header, null, _react["default"].createElement("h5", null, _react["default"].createElement(_core.Tag, {
      style: {
        color: area.color
      },
      minimal: true
    }, _react["default"].createElement(_reactFontawesome["default"], {
      name: "tag"
    })), ' ', area.name), _react["default"].createElement("div", null, _react["default"].createElement(_addShip.AddShip, {
      area: index,
      onSelect: this.handleAddShip
    }))), _react["default"].createElement("div", null, (0, _lodash.keys)(groupShipIds).map(idx => _react["default"].createElement(Lane, {
      key: idx
    }, _fp["default"].flow(_fp["default"].sortBy([id => -(0, _lodash.get)(keyShips[id], 'lv', 0), id => -id]), _fp["default"].map(id => _react["default"].createElement(_shipChip.ShipChip, {
      shipId: id,
      others: others,
      key: id,
      planArea: index
    })))(groupShipIds[idx])))));
  }

}, _temp));
exports.Area = Area;