"use strict";

exports.__esModule = true;
exports.ShipChip = void 0;

var _core = require("@blueprintjs/core");

var _lodash = require("lodash");

var _path = _interopRequireDefault(require("path"));

var _react = _interopRequireWildcard(require("react"));

var _reactFontawesome = _interopRequireDefault(require("react-fontawesome"));

var _reactI18next = require("react-i18next");

var _reactRedux = require("react-redux");

var _redux = require("redux");

var _styledComponents = _interopRequireDefault(require("styled-components"));

var _overlay = require("views/components/etc/overlay");

var _redux2 = require("../../redux");

var _selectors = require("../../selectors");

var _utils = require("../../utils");

var _temp;

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj["default"] = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

const Chip = (0, _styledComponents["default"])(_core.Tag).withConfig({
  displayName: "ship-chip__Chip",
  componentId: "sc-20bmwz-0"
})(["margin:0.5ex 1ex;"]);
const ShipChip = (0, _redux.compose)((0, _reactI18next.withTranslation)(['resources', 'poi-plugin-ship-info']), (0, _reactRedux.connect)((state, props) => ({ ...(0, _selectors.shipItemSelectorFactory)(props.shipId)(state),
  color: (0, _lodash.get)(state, 'fcd.shiptag.color', []),
  fleetId: (0, _selectors.shipFleetIdSelectorFactory)(props.shipId)(state)
})))((_temp = class ShipChipBase extends _react.PureComponent {
  constructor(...args) {
    super(...args);

    this.handleDisplace = areaIndex => () => {
      const {
        planArea,
        id
      } = this.props;
      this.props.dispatch((0, _redux2.onDisplaceShip)({
        fromAreaIndex: planArea,
        shipId: id,
        toAreaIndex: areaIndex
      }));
    };

    this.handleRemove = () => {
      const {
        id,
        planArea
      } = this.props;
      this.props.dispatch((0, _redux2.onRemoveShip)({
        areaIndex: planArea,
        shipId: id
      }));
    };

    this.componentDidUpdate = () => {
      const {
        area,
        planArea,
        id
      } = this.props;

      if (area > 0 && area - 1 !== planArea) {
        this.props.dispatch((0, _redux2.onDisplaceShip)({
          fromAreaIndex: planArea,
          shipId: id,
          toAreaIndex: area - 1
        }));
      }
    };
  }

  render() {
    const {
      typeId,
      name,
      lv,
      area,
      color,
      others,
      fleetId,
      t
    } = this.props;
    return _react["default"].createElement(Chip, {
      minimal: true,
      interactive: true,
      onRemove: this.handleRemove,
      onContextMenu: !(area > 0) ? this.handleRemove : undefined
    }, _react["default"].createElement(_overlay.Popover, {
      position: _core.Position.TOP,
      hasBackdrop: true,
      content: _react["default"].createElement(_core.Menu, null, others.map(_area => _react["default"].createElement(_core.MenuItem, {
        key: _area.color,
        onClick: this.handleDisplace(_area.areaIndex),
        text: _react["default"].createElement(_react["default"].Fragment, null, t('Move to '), ' ', _react["default"].createElement(_core.Tag, {
          minimal: true,
          style: {
            color: _area.color
          }
        }, _react["default"].createElement(_reactFontawesome["default"], {
          name: "tag"
        }), _area.name))
      })))
    }, _react["default"].createElement("span", null, _utils.shipTypes[typeId], ' | ', t(name), " ", _react["default"].createElement("span", null, "Lv.", lv))), _react["default"].createElement("span", null, area > 0 && _react["default"].createElement(_reactFontawesome["default"], {
      name: "tag",
      style: {
        marginLeft: '1ex',
        color: color[area - 1]
      }
    })), _react["default"].createElement("span", null, fleetId > -1 && _react["default"].createElement("img", {
      height: 16,
      alt: `fleet: ${fleetId + 1}`,
      src: (0, _utils.fileUrl)(_path["default"].resolve(__dirname, `../../../assets/images/fleet/${fleetId + 1}.png`))
    })));
  }

}, _temp));
exports.ShipChip = ShipChip;