"use strict";

exports.__esModule = true;
exports.ShipGrid = void 0;

var _fp = _interopRequireDefault(require("lodash/fp"));

var _react = _interopRequireWildcard(require("react"));

var _reactI18next = require("react-i18next");

var _reactRedux = require("react-redux");

var _styledComponents = _interopRequireDefault(require("styled-components"));

var _constants = require("../../constants");

var _redux = require("../../redux");

var _selectors = require("../../selectors");

var _shipItem = require("./ship-item");

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj["default"] = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

const getDPAction = (shipId, fill) => (dispatch, getState) => {
  const planMap = (0, _selectors.deckPlannerShipMapSelector)(getState());

  if (fill === planMap[shipId] || fill === -1 && !(shipId in planMap)) {
    return;
  }

  if (fill === -1) {
    dispatch((0, _redux.onRemoveShip)({
      areaIndex: planMap[shipId],
      shipId
    }));
    return;
  }

  if (!(shipId in planMap)) {
    dispatch((0, _redux.onAddShip)({
      areaIndex: fill,
      shipId
    }));
    return;
  }

  dispatch((0, _redux.onDisplaceShip)({
    fromAreaIndex: planMap[shipId],
    shipId,
    toAreaIndex: fill
  }));
};

const Grid = _styledComponents["default"].div.withConfig({
  displayName: "ship-grid__Grid",
  componentId: "sc-16owcdn-0"
})(["display:flex;flex-direction:row;flex-wrap:wrap;"]);

const ShipGrid = (0, _reactRedux.connect)(state => ({
  ships: (0, _selectors.shipMenuDataSelector)(state)
}), null, null, {
  forwardRef: true
})((0, _react.forwardRef)(({
  ships,
  dispatch,
  fill
}, ref) => {
  const handleClick = (0, _react.useCallback)(shipId => {
    dispatch(getDPAction(shipId, fill));
  }, [dispatch, fill]);
  const handleContextmenu = (0, _react.useCallback)(shipId => {
    dispatch(getDPAction(shipId, -1));
  }, [dispatch]);
  const {
    t
  } = (0, _reactI18next.useTranslation)(['poi-plugin-ship-info']);
  return _react["default"].createElement("div", {
    ref: ref
  }, _constants.shipSuperTypeMap.map(stype => _react["default"].createElement("div", {
    key: stype.name
  }, _react["default"].createElement("h2", null, t(stype.name)), _react["default"].createElement(Grid, null, _fp["default"].flow(_fp["default"].filter(ship => stype.id.includes(ship.typeId)), _fp["default"].sortBy([ship => -ship.lv, ship => -ship.id]), _fp["default"].map(ship => _react["default"].createElement(_shipItem.ShipItem, {
    ship: ship,
    key: ship.id // tslint:disable jsx-no-lambda
    ,
    onClick: () => handleClick(ship.id),
    onContextmenu: () => handleContextmenu(ship.id)
  })))(ships)))));
}));
exports.ShipGrid = ShipGrid;