"use strict";

exports.__esModule = true;
exports.SallyArea = void 0;

var _core = require("@blueprintjs/core");

var _react = _interopRequireDefault(require("react"));

var _reactFontawesome = _interopRequireDefault(require("react-fontawesome"));

var _reactI18next = require("react-i18next");

var _reactRedux = require("react-redux");

var _overlay = require("views/components/etc/overlay");

var _selectors = require("../selectors");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

const SallyArea = (0, _reactRedux.connect)( // @ts-ignore
(state, props) => {
  const {
    area
  } = props;
  const {
    mapname,
    color
  } = (0, _selectors.sallyAreaSelectorFactory)(area)(state);
  return {
    area,
    color,
    info_id: props.info_id || 0,
    mapname
  };
})(({
  area,
  mapname,
  color,
  info_id
}) => {
  const {
    t
  } = (0, _reactI18next.useTranslation)(['poi-plugin-ship-info']);

  if (area <= 0) {
    return null;
  }

  return _react["default"].createElement(_overlay.Tooltip, {
    position: _core.Position.TOP,
    content: t('ship_tag', {
      map: mapname
    })
  }, _react["default"].createElement(_core.Tag, {
    minimal: true,
    style: {
      color
    }
  }, _react["default"].createElement(_reactFontawesome["default"], {
    name: "tag"
  })));
});
exports.SallyArea = SallyArea;