"use strict";

exports.__esModule = true;
exports.Slotitems = void 0;

var _lodash = require("lodash");

var _path = _interopRequireDefault(require("path"));

var _polished = require("polished");

var _react = _interopRequireDefault(require("react"));

var _reactI18next = require("react-i18next");

var _reactRedux = require("react-redux");

var _styledComponents = _interopRequireDefault(require("styled-components"));

var _icon = require("views/components/etc/icon");

var _overlay = require("views/components/etc/overlay");

var _selectors = require("views/utils/selectors");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

const {
  ROOT
} = window;

const AlvImage = _styledComponents["default"].img.withConfig({
  displayName: "slotitems__AlvImage",
  componentId: "sc-9t1zct-0"
})(["height:14px;margin-bottom:2px;margin-left:1ex;"]);

const SlotItemContainer = _styledComponents["default"].div.withConfig({
  displayName: "slotitems__SlotItemContainer",
  componentId: "sc-9t1zct-1"
})(["position:relative;height:30px;img{height:30px;}"]);

const ExtraIndicator = _styledComponents["default"].div.withConfig({
  displayName: "slotitems__ExtraIndicator",
  componentId: "sc-9t1zct-2"
})(["position:absolute;right:0;bottom:0;line-height:1em;width:1em;height:1em;text-align:center;border-radius:100%;background:", ";"], props => (0, _polished.rgba)(props.theme.GREEN1, 0.4));

const Slotitem = ({
  item,
  isEx = false
}) => {
  const {
    t
  } = (0, _reactI18next.useTranslation)(['resources']);
  return _react["default"].createElement("div", null, _react["default"].createElement(_overlay.Tooltip, {
    content: _react["default"].createElement(_react["default"].Fragment, null, t(item.api_name || '', {
      keySeparator: 'chiba'
    }), item.api_level > 0 ? _react["default"].createElement("strong", {
      style: {
        color: '#45A9A5'
      }
    }, "\u2605+", item.api_level) : '', item.api_alv && item.api_alv <= 7 && item.api_alv >= 1 && _react["default"].createElement(AlvImage, {
      alt: "alv",
      src: _path["default"].join(ROOT, 'assets', 'img', 'airplane', `alv${item.api_alv}.png`)
    }))
  }, _react["default"].createElement(SlotItemContainer, null, _react["default"].createElement(_icon.SlotitemIcon, {
    slotitemId: (0, _lodash.get)(item, 'api_type.3', -1)
  }), isEx && _react["default"].createElement(ExtraIndicator, null, "+"))));
};

const Slotitems = (0, _reactRedux.connect)((state, {
  slot,
  exslot
}) => {
  const items = (0, _lodash.map)((0, _lodash.filter)(slot, itemId => itemId > 0), itemId => {
    const [item = {}, $item = {}] = (0, _selectors.equipDataSelectorFactory)(itemId)(state) || [];
    return { ...$item,
      ...item
    };
  });
  let exitem;

  if (exslot > 0) {
    const [item = {}, $item = {}] = (0, _selectors.equipDataSelectorFactory)(exslot)(state) || [];
    exitem = { ...$item,
      ...item
    };
  }

  return {
    exitem,
    items
  };
})(({
  items,
  exitem
}) => _react["default"].createElement(_react["default"].Fragment, null, items && items.map(item => _react["default"].createElement(Slotitem, {
  item: item,
  key: item.api_id || 0
})), exitem && _react["default"].createElement(Slotitem, {
  item: exitem,
  isEx: true
})));
exports.Slotitems = Slotitems;