"use strict";

exports.__esModule = true;
exports.TitleCell = exports.noop = void 0;

var _react = _interopRequireDefault(require("react"));

var _reactFontawesome = _interopRequireDefault(require("react-fontawesome"));

var _reactI18next = require("react-i18next");

var _styledComponents = _interopRequireDefault(require("styled-components"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

const noop = () => {
  /* do nothing */
};

exports.noop = noop;

const TitleCellContainer = _styledComponents["default"].div.withConfig({
  displayName: "title-cell__TitleCellContainer",
  componentId: "sc-1aa7mlv-0"
})(["text-align:", ";cursor:", ";color:", ";line-height:35px;"], props => props.centerAlign && 'center', props => props.sortable && 'pointer', props => props.sorting && props.theme.BLUE5);

const TitleCell = ({
  title,
  sortable,
  onClick,
  sorting,
  up,
  ...props
}) => {
  const {
    t
  } = (0, _reactI18next.useTranslation)(['poi-plugin-ship-info']);
  return _react["default"].createElement(TitleCellContainer, _extends({}, props, {
    role: "button",
    tabIndex: 0,
    onClick: sortable ? onClick : noop,
    sorting: sorting,
    sortable: sortable
  }), t(title), sorting && _react["default"].createElement(_reactFontawesome["default"], {
    name: up ? 'sort-up' : 'sort-down'
  }));
};

exports.TitleCell = TitleCell;